(function(){

const K = window.K;

K.NateSvgDom = class K_NateSvgDom extends K.NateAbstractDom
{
  constructor(parentOrElem)
  {
    super(parentOrElem);

    // Check the type of parentOrElem.
    const isInstanceOfSvgDom = (parentOrElem instanceof K.NateSvgDom);
    const isElemOrText       = K.Elem.isElem(parentOrElem) || K.Elem.isText(parentOrElem);

    if ((!isInstanceOfSvgDom) && (!isElemOrText))
    {
      throw 'parentOrElem should be Nate object or html-element';
    }
  }

  newSVGElement(tag, attrs)
  {
    const elem    = document.createElementNS('http://www.w3.org/2000/svg', tag);
    const newNate = new K.NateSvgDom(elem);

    this.addNateChild(newNate);

    if (K.Object.isNotNull(attrs))
    {
      for (var k in attrs)
      {
        newNate.set(k, attrs[k]);
      }
    }

    return newNate;
  }

  set(key, value)
  {
    if (key == 'xlink:href')
    {
      this.elem.setAttributeNS('http://www.w3.org/1999/xlink', 'href', value);
    }
    else
    {
      this.elem.setAttribute(key, value);
    }

    return this;
  }

  newCircle(attr)
  {
    return this.newSVGElement('circle', attr);
  }

  newPath(attr)
  {
    return this.newSVGElement('path', attr);
  }

  newLine(attr)
  {
    return this.newSVGElement('line', attr);
  }

  newPolyLine(attr)
  {
    return this.newSVGElement('polyline', attr);
  }

  clear()
  {
    this.deleteAllChildren();
  }
}

}).call(this);
